package trismegistoplanilla.sqlserverdao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONArray;
import org.json.JSONObject;
import trismegistoplanilla.beans.FondoPensionBean;
import trismegistoplanilla.dao.FondoPensionDAO;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class FondoPensionSqlserverDAO implements FondoPensionDAO {

	@Override
	public JSONObject listarFondoPension() {
		System.out.println("FondoPensionSqlserverDAO: listarFondoPension");
		JSONObject jsonListarFondoPension = null;
		JSONArray jsonArrayListarFondoPension = new JSONArray();
		Connection connection = null;
		PreparedStatement ps = null;
		ResultSet rs = null;

		ResponseHelper response = new ResponseHelper();

		try {
			connection = SqlserverDAOFactory.obtenerConexion(Variables.BD_NAME);
			String sql
				= "select "
				+ "codigo_fondo_pension codigoFondoPension, "
				+ "descripcion_corta descripcionCorta, "
				+ "descripcion_larga descripcionLarga, "
				+ "estado_registro estadoRegistro "
				+ "FROM fondo_pension "
				+ "where estado_registro = 1";
			ps = connection.prepareStatement(sql);
			rs = ps.executeQuery();
			while (rs.next()) {
				FondoPensionBean fondoPension = new FondoPensionBean();
				fondoPension.setCodigoFondoPension(rs.getInt("codigoFondoPension"));
				fondoPension.setDescripcionCorta(rs.getString("descripcionCorta"));
				fondoPension.setDescripcionLarga(rs.getString("descripcionLarga").trim());
				JSONObject jsonObjFondoPension = new JSONObject(fondoPension);
				jsonArrayListarFondoPension.put(jsonObjFondoPension);
			}
			JSONObject jsonObjFondoPension = new JSONObject();
			jsonObjFondoPension.put("fondopension", jsonArrayListarFondoPension);

			response.setStatus(true);
			response.setMessage("Los fondos de pensiones se han listado correctamente");
			response.setData(jsonObjFondoPension);

		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (connection != null) {
					connection.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		jsonListarFondoPension = new JSONObject(response);
		return jsonListarFondoPension;
	}

	@Override
	public JSONObject validarExistenciaFondoPension(FondoPensionBean fondoPension) {
		System.out.println("FondoPensionSqlserverDAO: validarExistenciaFondoPension");
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}

}
