package trismegistoplanilla.sqlserverdao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Iterator;
import org.json.JSONArray;
import org.json.JSONObject;
import trismegistoplanilla.beans.ReportePersonalBean;
import trismegistoplanilla.dao.ReportePersonalDAO;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class ReportePersonalSqlserverDAO implements ReportePersonalDAO {

	@Override
	public JSONObject validarExistenciaFilas(JSONObject jsonResult) {
		System.out.println("ReportePersonalSqlserverDAO: validarExistenciaFilas");
		JSONObject JOReporte = null;
		ResponseHelper response = new ResponseHelper();
		String condicion = "";
		// get keys jsonResult {"codigoTipoDocumento":1,"id":"c7dda616-83fe-827b-757a-463b8fe29afb","nombreTipoDocumento":"L.E / DNI"}
		Iterator<String> keys = jsonResult.keys();
		while (keys.hasNext()) {
			switch (keys.next()) {
				case "tipoDocumento":
					int codigoTipoDocumento = jsonResult.getJSONObject("tipoDocumento").getInt("codigoTipoDocumento");
					if (condicion.equals("")) {
						condicion += " where tipo_documento.codigo_tipo_documento = " + codigoTipoDocumento + " ";
					} else {
						condicion += " and tipo_documento.codigo_tipo_documento = " + codigoTipoDocumento + " ";
					}
					break;
				case "nacionalidad":
					int codigoNacionalidad = jsonResult.getJSONObject("nacionalidad").getInt("codigoNacionalidad");
					if (condicion.equals("")) {
						condicion += " where nacionalidad.codigo_nacionalidad = " + codigoNacionalidad + " ";
					} else {
						condicion += " and nacionalidad.codigo_nacionalidad = " + codigoNacionalidad + " ";
					}
					break;
				case "parentesco":
					int codigoParentesco = jsonResult.getJSONObject("parentesco").getInt("codigoParentesco");
					if (condicion.equals("")) {
						condicion += "where (select count(1) from carga_familiar where codigo_parentesco = " + codigoParentesco + " and numero_documento in (select p.numero_documento from persona p where p.numero_documento = persona.numero_documento )) > 0";
					} else {
						condicion += " and (select count(1) from carga_familiar where codigo_parentesco = " + codigoParentesco + " and numero_documento in (select p.numero_documento from persona p where p.numero_documento = persona.numero_documento )) > 0";
					}
					break;
				case "fechaNacimiento":
					int codigoCriterioFechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getInt("codigoCriterioFecha");
					String fechaNacimiento = "";
					if (condicion.equals("")) {
						switch (codigoCriterioFechaNacimiento) {
							case 1: // igual a
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += "where persona.fecha_nacimiento = '" + fechaNacimiento + "'";
								break;
							case 2: // mayor igual
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += "where persona.fecha_nacimiento >= '" + fechaNacimiento + "'";
								break;
							case 3: // menor igual
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += "where persona.fecha_nacimiento <= '" + fechaNacimiento + "'";
								break;
							case 4: // entre
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimientoInicio");
								String fechaNacimientoFin = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimientoFin");
								condicion += "where persona.fecha_nacimiento between '" + fechaNacimiento + "' and '" + fechaNacimientoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					} else {
						switch (codigoCriterioFechaNacimiento) {
							case 1: // igual a
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += " and persona.fecha_nacimiento = '" + fechaNacimiento + "'";
								break;
							case 2: // mayor igual
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += " and persona.fecha_nacimiento >= '" + fechaNacimiento + "'";
								break;
							case 3: // menor igual
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimiento");
								condicion += " and persona.fecha_nacimiento <= '" + fechaNacimiento + "'";
								break;
							case 4: // entre
								fechaNacimiento = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimientoInicio");
								String fechaNacimientoFin = jsonResult.getJSONObject("fechaNacimiento").getString("fechaNacimientoFin");
								condicion += " and persona.fecha_nacimiento between '" + fechaNacimiento + "' and '" + fechaNacimientoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					}
					break;
				case "fechaIngreso":
					int codigoCriterioFechaIngreso = jsonResult.getJSONObject("fechaIngreso").getInt("codigoCriterioFecha");
					String fechaIngreso = "";
					if (condicion.equals("")) {
						switch (codigoCriterioFechaIngreso) {
							case 1: // igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += "where ficha_laboral.fecha_ingreso = '" + fechaIngreso + "'";
								break;
							case 2: // mayor igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += "where ficha_laboral.fecha_ingreso >= '" + fechaIngreso + "'";
								break;
							case 3: // menor igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += "where ficha_laboral.fecha_ingreso <= '" + fechaIngreso + "'";
								break;
							case 4: // entre
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngresoInicio");
								String fechaIngresoFin = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngresoFin");
								condicion += "where ficha_laboral.fecha_ingreso between '" + fechaIngreso + "' and '" + fechaIngresoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					} else {
						switch (codigoCriterioFechaIngreso) {
							case 1: // igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += " and ficha_laboral.fecha_ingreso = '" + fechaIngreso + "'";
								break;
							case 2: // mayor igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += " and ficha_laboral.fecha_ingreso >= '" + fechaIngreso + "'";
								break;
							case 3: // menor igual a
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngreso");
								condicion += " and ficha_laboral.fecha_ingreso <= '" + fechaIngreso + "'";
								break;
							case 4: // entre
								fechaIngreso = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngresoInicio");
								String fechaIngresoFin = jsonResult.getJSONObject("fechaIngreso").getString("fechaIngresoFin");
								condicion += " and ficha_laboral.fecha_ingreso between '" + fechaIngreso + "' and '" + fechaIngresoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					}
					break;
				case "fechaTermino":
					int codigoCriterioFechaFin = jsonResult.getJSONObject("fechaTermino").getInt("codigoCriterioFecha");
					String fechaTermino = "";
					if (condicion.equals("")) {
						switch (codigoCriterioFechaFin) {
							case 1: // igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += "where ficha_laboral.fecha_fin = '" + fechaTermino + "'";
								break;
							case 2: // mayor igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += "where ficha_laboral.fecha_fin >= '" + fechaTermino + "'";
								break;
							case 3: // menor igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += "where ficha_laboral.fecha_fin <= '" + fechaTermino + "'";
								break;
							case 4: // entre
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTerminoInicio");
								String fechaTerminoFin = jsonResult.getJSONObject("fechaTermino").getString("fechaTerminoFin");
								condicion += "where ficha_laboral.fecha_fin between '" + fechaTermino + "' and '" + fechaTerminoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					} else {
						switch (codigoCriterioFechaFin) {
							case 1: // igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += " and ficha_laboral.fecha_fin = '" + fechaTermino + "'";
								break;
							case 2: // mayor igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += " and ficha_laboral.fecha_fin >= '" + fechaTermino + "'";
								break;
							case 3: // menor igual a
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTermino");
								condicion += " and ficha_laboral.fecha_fin <= '" + fechaTermino + "'";
								break;
							case 4: // entre
								fechaTermino = jsonResult.getJSONObject("fechaTermino").getString("fechaTerminoInicio");
								String fechaTerminoFin = jsonResult.getJSONObject("fechaTermino").getString("fechaTerminoFin");
								condicion += " and ficha_laboral.fecha_fin between '" + fechaTermino + "' and '" + fechaTerminoFin + "' ";
								break;
							default:
								condicion += "";
								break;
						}
					}
					break;
				case "sede":
					if (condicion.equals("")) {
						if (jsonResult.getJSONObject("sede").isNull("codigoSedeArea") && jsonResult.getJSONObject("sede").isNull("codigoAreaCargo")) {
							int codigoSede = jsonResult.getJSONObject("sede").getInt("codigoSede");
							condicion += " where sede.codigo_sede = " + codigoSede + " ";
						} else if (jsonResult.getJSONObject("sede").isNull("codigoAreaCargo")) {
							int codigo_sede_area = jsonResult.getJSONObject("sede").getInt("codigoSedeArea");
							condicion += " where sede_area.codigo_sede_area = " + codigo_sede_area + " ";
						} else if (!(jsonResult.getJSONObject("sede").isNull("codigoSedeArea")) && !(jsonResult.getJSONObject("sede").isNull("codigoAreaCargo"))) {
							int codigo_sede_area = jsonResult.getJSONObject("sede").getInt("codigoSedeArea");
							int codigo_area_cargo = jsonResult.getJSONObject("sede").getInt("codigoAreaCargo");
							condicion += " where sede_area.codigo_sede_area = " + codigo_sede_area + " and area_cargo.codigo_area_cargo = " + codigo_area_cargo + " ";
						}
					} else {
						if (jsonResult.getJSONObject("sede").isNull("codigoSedeArea") && jsonResult.getJSONObject("sede").isNull("codigoAreaCargo")) {
							int codigoSede = jsonResult.getJSONObject("sede").getInt("codigoSede");
							condicion += " and sede.codigo_sede = " + codigoSede + " ";
						} else if (jsonResult.getJSONObject("sede").isNull("codigoAreaCargo")) {
							int codigo_sede_area = jsonResult.getJSONObject("sede").getInt("codigoSedeArea");
							condicion += " and sede_area.codigo_sede_area = " + codigo_sede_area + " ";
						} else if (!(jsonResult.getJSONObject("sede").isNull("codigoSedeArea")) && !(jsonResult.getJSONObject("sede").isNull("codigoAreaCargo"))) {
							int codigo_sede_area = jsonResult.getJSONObject("sede").getInt("codigoSedeArea");
							int codigo_area_cargo = jsonResult.getJSONObject("sede").getInt("codigoAreaCargo");
							condicion += " and sede_area.codigo_sede_area = " + codigo_sede_area + " and area_cargo.codigo_area_cargo = " + codigo_area_cargo + " ";
						}
					}
					break;
				case "estado":
					break;
				default:
					condicion = "";					
			}
		}

		String sql = ""
			+ "select "
			+ "count(1) existeFilas "
			+ "from persona "
			+ "inner join dbo.tipo_documento ON dbo.tipo_documento.codigo_tipo_documento = dbo.persona.codigo_tipo_documento "
			+ "left join dbo.estado_civil ON dbo.estado_civil.codigo_estado_civil = dbo.persona.codigo_estado_civil "
			+ "left join dbo.nacionalidad ON dbo.nacionalidad.codigo_nacionalidad = dbo.persona.codigo_nacionalidad "
			+ "left join dbo.fondo_pension ON dbo.fondo_pension.codigo_fondo_pension = dbo.persona.codigo_fondo_pension "
			+ "inner join dbo.ficha ON dbo.ficha.codigo_persona = dbo.persona.codigo_persona "
			+ "left join dbo.ficha_laboral ON dbo.ficha_laboral.codigo_ficha = dbo.ficha.codigo_ficha "
			+ "left join dbo.sede_area ON dbo.sede_area.codigo_sede_area = dbo.ficha_laboral.codigo_sede_area "
			+ "left join dbo.sede ON dbo.sede.codigo_sede = dbo.sede_area.codigo_sede "
			+ "left join dbo.area ON dbo.area.codigo_area = dbo.sede_area.codigo_area "
			+ "left join dbo.area_cargo ON dbo.area_cargo.codigo_area_cargo = dbo.ficha_laboral.codigo_area_cargo "
			+ "left join dbo.cargo ON dbo.cargo.codigo_cargo = dbo.area_cargo.codigo_cargo "
			+ condicion;
		
		Connection conexion = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			conexion = SqlserverDAOFactory.obtenerConexion(Variables.BD_NAME);
			ps = conexion.prepareStatement(sql);
			rs = ps.executeQuery();
			rs.next();
			int existeFilas = rs.getInt("existeFilas");
			if (existeFilas > 0) {
				JSONObject objReportePersonal = listarReportePersonal(condicion);
				response.setStatus(objReportePersonal.getBoolean("status"));
				response.setMessage(objReportePersonal.getString("message"));
				response.setData(objReportePersonal);
			} else {
				response.setStatus(false);
				response.setMessage("No se ha encontrado registros con el criterio que acaba de ingresar");
			}
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (conexion != null) {
					conexion.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		JOReporte = new JSONObject(response);
		return JOReporte;
	}

	@Override
	public JSONObject listarReportePersonal(String condicion) {
		System.out.println("ReportePersonalSqlserverDAO: listarReportePersonal");
		JSONObject JOReporte = null;
		JSONArray JAReporte = new JSONArray();
		ResponseHelper response = new ResponseHelper();
		String sql = ""
			+ "select "
			+ "persona.codigo_persona codigoPersona, "
			+ "isnull(persona.apellido_paterno, '-') apellidoPaterno, "
			+ "isnull(persona.apellido_materno, '-') apellidoMaterno, "
			+ "isnull(persona.nombre, '-') nombre, "
			+ "isnull(tipo_documento.descripcion_corta, '-') tipoDocumento, "
			+ "isnull(persona.numero_documento, '-') numeroDocumento, "
			+ "isnull(persona.sexo, '-') sexo, "
			+ "isnull(estado_civil.nombre, '-') estadoCivil, "
			+ "isnull(convert(varchar, persona.fecha_nacimiento, 103), '-') fechaNacimiento, "
			+ "isnull(nacionalidad.pais, '-') nacionalidad, "
			+ "case when persona.codigo_nacionalidad = 144 then (select ubigeo.nombre_departamento + ' - ' + ubigeo.nombre_provincia + ' - ' + ubigeo.nombre_distrito from ubigeo where ubigeo.codigo_ubigeo = persona.codigo_ubigeo_nacimiento) else '-' end ubigeoNacimiento, "
			+ "isnull(persona.direccion_documento, '-') direccionDocumento, "
			+ "case when persona.telefono_fijo is null or persona.telefono_fijo = '' then '-' else persona.telefono_fijo end telefonoFijo, "
			+ "case when persona.telefono_movil is null or persona.telefono_movil = '' then '-' else persona.telefono_movil end telefonoMovil, "
			+ "persona.correo correoPersonal, "
			+ "isnull(persona.correo_corporativo, '-') correoCorporativo, "
			+ "isnull((select ubigeo.nombre_departamento + ' - ' + ubigeo.nombre_provincia + ' - ' + ubigeo.nombre_distrito from ubigeo where ubigeo.codigo_ubigeo = persona.codigo_ubigeo_residencia), '-') ubigeoResidencia, "
			+ "isnull(persona.direccion_residencia, '-') direccionResidencia, "
			+ "isnull(persona.latitud_residencia + ' , ' + persona.longitud_residencia, '-') coordenadasDireccionResidencia, "
			+ "isnull(persona.foto, '-') foto, "
			+ "rtrim(ltrim(isnull(persona.ruc, '-'))) ruc,"
			+ "case when persona.fondo_pension_activo = 1 then 'SI' when persona.fondo_pension_activo is null then '-' else 'NO' end tieneFondoPension, "
			+ "isnull(fondo_pension.descripcion_corta, '-') fondoPension, "
			+ "isnull(persona.enlace_alfresco, '-') enlaceAlfresco, "
			+ "case when persona.is_default_mail = 1 then 'NO' when persona.is_default_mail is null then '-' else 'SI' end tieneCorreo, "
			+ "isnull(sede.nombre, '-') sede, "
			+ "isnull(area.nombre, '-') area, "
			+ "isnull(cargo.nombre, '-') cargo, "
			+ "isnull(convert(varchar, ficha_laboral.fecha_ingreso, 103), '-') fechaIngreso, "
			+ "isnull(convert(varchar, ficha_laboral.fecha_fin, 103), '-') fechaTermino, "
			+ "(select count(1) from carga_familiar where numero_documento in (select p.numero_documento from persona p where p.numero_documento = dbo.persona.numero_documento )) cantidadParentesco "
			+ "from persona "
			+ "inner join dbo.tipo_documento ON dbo.tipo_documento.codigo_tipo_documento = dbo.persona.codigo_tipo_documento "
			+ "left join dbo.estado_civil ON dbo.estado_civil.codigo_estado_civil = dbo.persona.codigo_estado_civil "
			+ "left join dbo.nacionalidad ON dbo.nacionalidad.codigo_nacionalidad = dbo.persona.codigo_nacionalidad "
			+ "left join dbo.fondo_pension ON dbo.fondo_pension.codigo_fondo_pension = dbo.persona.codigo_fondo_pension "
			+ "inner join dbo.ficha ON dbo.ficha.codigo_persona = dbo.persona.codigo_persona "
			+ "left join dbo.ficha_laboral ON dbo.ficha_laboral.codigo_ficha = dbo.ficha.codigo_ficha "
			+ "left join dbo.sede_area ON dbo.sede_area.codigo_sede_area = dbo.ficha_laboral.codigo_sede_area "
			+ "left join dbo.sede ON dbo.sede.codigo_sede = dbo.sede_area.codigo_sede "
			+ "left join dbo.area ON dbo.area.codigo_area = dbo.sede_area.codigo_area "
			+ "left join dbo.area_cargo ON dbo.area_cargo.codigo_area_cargo = dbo.ficha_laboral.codigo_area_cargo "
			+ "left join dbo.cargo ON dbo.cargo.codigo_cargo = dbo.area_cargo.codigo_cargo "
			+ condicion;
		
		Connection conexion = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			conexion = SqlserverDAOFactory.obtenerConexion(Variables.BD_NAME);
			ps = conexion.prepareStatement(sql);
			rs = ps.executeQuery();
			while (rs.next()) {
				ReportePersonalBean rp = new ReportePersonalBean();
				rp.setCodigoPersona(rs.getString("codigoPersona"));
				rp.setApellidoPaterno(rs.getString("apellidoPaterno"));
				rp.setApellidoMaterno(rs.getString("apellidoMaterno"));
				rp.setNombre(rs.getString("nombre"));
				rp.setTipoDocumento(rs.getString("tipoDocumento"));
				rp.setNumeroDocumento(rs.getString("numeroDocumento"));
				rp.setSexo(rs.getString("sexo"));
				rp.setEstadoCivil(rs.getString("estadoCivil"));
				rp.setFechaNacimiento(rs.getString("fechaNacimiento"));
				rp.setNacionalidad(rs.getString("nacionalidad"));
				rp.setUbigeoNacimiento(rs.getString("ubigeoNacimiento"));
				rp.setDireccionDocumento(rs.getString("direccionDocumento"));
				rp.setTelefonoFijo(rs.getString("telefonoFijo"));
				rp.setTelefonoMovil(rs.getString("telefonoMovil"));
				rp.setCorreoPersonal(rs.getString("correoPersonal"));
				rp.setCorreoCorporativo(rs.getString("correoCorporativo"));
				rp.setUbigeoResidencia(rs.getString("ubigeoResidencia"));
				rp.setDireccionResidencia(rs.getString("direccionResidencia"));
				rp.setCoordenadasDireccionResidencia(rs.getString("coordenadasDireccionResidencia"));
				rp.setFoto(rs.getString("foto"));
				rp.setRuc(rs.getString("ruc"));
				rp.setTieneFondoPension(rs.getString("tieneFondoPension"));
				rp.setFondoPension(rs.getString("fondoPension"));
				rp.setEnlaceAlfresco(rs.getString("enlaceAlfresco"));
				rp.setTieneCorreo(rs.getString("tieneCorreo"));
				rp.setSede(rs.getString("sede"));
				rp.setArea(rs.getString("area"));
				rp.setCargo(rs.getString("cargo"));
				rp.setFechaIngreso(rs.getString("fechaIngreso"));
				rp.setFechaTermino(rs.getString("fechaTermino"));
				rp.setCantidadParentesco(rs.getString("cantidadParentesco"));
				JSONObject objReportePersonal = new JSONObject(rp);
				JAReporte.put(objReportePersonal);
			}
			JSONObject objReportePersonal = new JSONObject();
			objReportePersonal.put("reportePersonal", JAReporte);
			response.setStatus(true);
			response.setMessage("Reporte listado correctamente.");
			response.setData(objReportePersonal);
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (conexion != null) {
					conexion.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		JOReporte = new JSONObject(response);
		return JOReporte;
	}
	
}
