let DOMEvents = {
  accionesTabla() {
    $('#tblFichas tbody').on('click', '.verDetalle', (e) => {
      let rowData = $('#tblFichas').DataTable().row($(e.currentTarget).parents('tr')).data()
      if (lote.codigoEstadoLote === 1) {
        httpRequest.obtenerDetallePendiente({codigoPersona: rowData.codigoPersona, codigoFicha: rowData.codigoFicha, tipoFicha: lote.tipoLote})
          .then((data) => {
            localStorage.setItem('detalleFichaLote', JSON.stringify(data))
            localStorage.setItem('paginaActual', 'detalleConsultaLotesGeneral')
            window.location.href = 'detalleFicha.jsp'
          })
          .catch(err => jAlert({type: 'error', content: err, buttons: {left: 'Aceptar'}}))
      } else {
        httpRequest.obtenerDetalle(rowData)
          .then(data => {
            setLocal('detalleLoteGeneral', data.data.persona)
            localStorage.setItem('paginaActual', 'detalleConsultaLotesGeneral')
            window.location = 'fichadetalle.jsp'
          })
      }
    })
  }

};
let inicializarComponentes = {

};
let printElements = {
  pintarLote() {
    document.querySelector('#lblNumeroLote').innerHTML = lote.numeroLote;
    document.querySelector('#lblFechaRegistro').innerHTML = lote.fechaRegistro;
    let estiloTipoLote = lote.tipoLote === 'A' ? 'bg-primary' : 'bg-success';
    let tipoLote = lote.tipoLote === 'A' ? 'ADMINISTRATIVO' : 'DOCENTE';
    document.querySelector('#divLote').innerHTML = `
            <div class="form-group">
              <label class="text-semibold">Tipo de lote:</label>
              <span class="pull-right-sm label ${estiloTipoLote}">${tipoLote}</span>
            </div>
            <div class="form-group">
              <label class="text-semibold">Estado de lote:</label>
              <span class="pull-right-sm ${lote.estilo}">${lote.estadoLote}</span>
            </div>
    `;
  },
  cabezeraTabla() {
    return new Promise((resolve) => {
      let header = '';
      if (lote.tipoLote === 'A') {
        if (lote.codigoEstadoLote !== 1) {
          header = `
                <thead>
                  <tr>
                    <th class="text-center" rowspan="2">#</th>
                    <th class="text-center" rowspan="2">APELLIDOS Y NOMBRES</th>
                    <th class="text-center" rowspan="2">TIPO DOCUMENTO</th>
                    <th class="text-center" rowspan="2">N° DOCUMENTO</th>
                    <th class="text-center" rowspan="2">FECHA INGRESO</th>
                    <th class="text-center" colspan="3" style="text-align: center;">COSTOS</th>
                    <th class="text-center" rowspan="2">ACCIONES</th>
                  </tr>
                  <tr>
                    <th class="text-center">SUELDO ESCALAFON</th>
                    <th class="text-center">SUELDO PROPUESTO</th>
                    <th class="text-center">SUELDO PRESIDENCIA</th>
                  </tr>
                </thead>
                `;
        } else {
          header = `
                <thead>
                  <tr>
                    <th class="text-center" rowspan="2">#</th>
                    <th class="text-center" rowspan="2">APELLIDOS Y NOMBRES</th>
                    <th class="text-center" rowspan="2">TIPO DOCUMENTO</th>
                    <th class="text-center" rowspan="2">N° DOCUMENTO</th>
                    <th class="text-center" rowspan="2">FECHA INGRESO</th>
                    <th class="text-center" colspan="2" style="text-align: center;">COSTOS</th>
                    <th class="text-center" rowspan="2">ACCIONES</th>
                  </tr>
                  <tr>
                    <th class="text-center">SUELDO ESCALAFON</th>
                    <th class="text-center">SUELDO PROPUESTO</th>
                  </tr>
                </thead>
                `;
        }
      } else if (lote.tipoLote === 'D') {
        header = `
                <thead>
                  <tr>
                    <th class="text-center" rowspan="2">#</th>
                    <th class="text-center" rowspan="2">APELLIDOS Y NOMBRES</th>
                    <th class="text-center" rowspan="2">TIPO DOCUMENTO</th>
                    <th class="text-center" rowspan="2">N° DOCUMENTO</th>
                    <th class="text-center" rowspan="2">FECHA INGRESO</th>
                    <th class="text-center" colspan="4" style="text-align: center;">COSTOS</th>
                    <th class="text-center" rowspan="2">ACCIONES</th>
                  </tr>
                  <tr>
                    <th class="text-center">COSTO MENSUAL</th>
                    <th class="text-center">A</th>
                    <th class="text-center">B</th>
                    <th class="text-center">C</th>
                  </tr>
                </thead>
                `;
      } else {
        window.location = 'consultaLotesGeneral.jsp'
      }

      resolve(document.querySelector('#tblFichas').innerHTML = header);
    });
  },
  cuerpoTabla(tipoLote) {
    defaultConfigDataTable();
    let count = 0;
    if (tipoLote === 'A') {
      if (lote.codigoEstadoLote !== 1) {
        $(document.querySelector('#tblFichas')).DataTable({
          bInfo: false,
          paging: false,
          data: lote.fichas,
          columns: [
            {
              data: null,
              className: 'text-center',
              render: () => ++count
            },
            {
              data: null,
              render: (data) => `${data.apellidoPaterno} ${data.apellidoMaterno} ${data.nombre}`
            },
            {
              data: 'tipoDocumento',
              className: 'text-center'

            },
            {
              data: 'numeroDocumento',
              className: 'text-center'

            },
            {
              data: 'fechaIngreso',
              className: 'text-center'

            },
            {
              data: 'sueldoEscalafon',
              className: 'text-center',
              render: (data) => `<b> S/. ${data} </b>`
            },
            {
              data: 'sueldoMensual',
              className: 'text-center',
              render: (data) => `<b> S/. ${data} </b>`
            },
            {
              data: 'sueldoPresidencia',
              className: 'text-center',
              render: (data) => `<mark style="font-size: 16px;"> S/. ${data} </mark>`
            },
            {
              data: null,
              className: 'text-center',
              render: () => `
                          <ul class="icons-list">
                              <li class="text-primary">
                                  <a href="#" onclick="javascript:return false;" class="verDetalle" data-toggle="tooltip" data-placement="top" title="VER DETALLE">
                                    <i style="font-size: 22px;" class="fa fa-file-text-o fa-lg"></i>
                                  </a>
                              </li>
                          </ul>
                          `
            }
          ],
          initComplete: (settings, data) => {
            $('.verDetalle').tooltip({
              position: {
                my: "center bottom", // the "anchor point" in the tooltip element
                at: "center top" // the position of that anchor point relative to selected element
              },
              hide: {effect: "explode"}
            });
          },
          fnRowCallback: (row, data, index, iDisplayIndexFull) => {
            if (parseFloat(data.sueldoMensual) > parseFloat(data.sueldoEscalafon)) {
              $(row).css('background-color', '#ffeee2');
            }
          }
        });
      } else {
        $(document.querySelector('#tblFichas')).DataTable({
          bInfo: false,
          paging: false,
          data: lote.fichas,
          columns: [
            {
              data: null,
              className: 'text-center',
              render: () => ++count
            },
            {
              data: null,
              render: (data) => `${data.apellidoPaterno} ${data.apellidoMaterno} ${data.nombre}`
            },
            {
              data: 'tipoDocumento',
              className: 'text-center'

            },
            {
              data: 'numeroDocumento',
              className: 'text-center'

            },
            {
              data: 'fechaIngreso',
              className: 'text-center'

            },
            {
              data: 'sueldoEscalafon',
              className: 'text-center',
              render: (data) => `<b> S/. ${data} </b>`
            },
            {
              data: 'sueldoMensual',
              className: 'text-center',
              render: (data) => `<b> S/. ${data} </b>`
            },
            {
              data: null,
              className: 'text-center',
              render: () => `
                          <ul class="icons-list">
                              <li class="text-primary">
                                  <a href="#" onclick="javascript:return false;" class="verDetalle" data-toggle="tooltip" data-placement="top" title="VER DETALLE">
                                    <i style="font-size: 22px;" class="fa fa-file-text-o fa-lg"></i>
                                  </a>
                              </li>
                          </ul>
                          `
            }
          ],
          initComplete: (settings, data) => {
            $('.verDetalle').tooltip({
              position: {
                my: "center bottom", // the "anchor point" in the tooltip element
                at: "center top" // the position of that anchor point relative to selected element
              },
              hide: {effect: "explode"}
            });
          },
          fnRowCallback: (row, data, index, iDisplayIndexFull) => {
            if (parseFloat(data.sueldoMensual) > parseFloat(data.sueldoEscalafon)) {
              $(row).css('background-color', '#ffeee2');
            }
          }
        });
      }
    } else if (tipoLote === 'D') {
      $(document.querySelector('#tblFichas')).DataTable({
        bInfo: false,
        paging: false,
        data: lote.fichas,
        columns: [
          {
            data: null,
            render: () => ++count
          },
          {
            data: null,
            render: (data) => `${data.apellidoPaterno} ${data.apellidoMaterno} ${data.nombre}`
          },
          {
            data: 'tipoDocumento'

          },
          {
            data: 'numeroDocumento'

          },
          {
            data: 'fechaIngreso'

          },
          {
            data: 'costoMensualDocente',
            render: (data) => data !== '0.00' ? `<b> S/. ${data} </b>` : ' - '
          },
          {
            data: 'costoaDocente',
            render: (data) => data !== '0.00' ? `<b> S/. ${data} </b>` : ' - '
          },
          {
            data: 'costobDocente',
            render: (data) => data !== '0.00' ? `<b> S/. ${data} </b>` : ' - '
          },
          {
            data: 'costocDocente',
            render: (data) => data !== '0.00' ? `<b> S/. ${data} </b>` : ' - '
          },
          {
            data: null,
            render: () => `
                          <ul class="icons-list">
                              <li class="text-blue-800">
                                  <a href="#" onclick="javascript: return false;" class="verDetalle" data-toggle="tooltip" data-placement="top" title="VER DETALLE">
                                    <i class="fa fa-file-text-o fa-lg"></i>
                                  </a>
                              </li>
                          </ul>
                          `
          }
        ],
        initComplete: (settings, data) => {

        },
        fnRowCallback: (row, data, index, iDisplayIndexFull) => {
          if ($(row).hasClass('odd')) {
            $(row).css('background-color', '#e8f4f4');
          }
        }
      });
    }
  }
};
let httpRequest = {
  obtenerDetalle(obj) {
    return new Promise((resolve, reject) => {
      $.ajax({
        url: '../FichaServlet',
        type: 'POST',
        dataType: 'json',
        data: {
          accion: 'listarDetalleFichaPresidencia',
          codigoPersona: obj.codigoPersona,
          codigoFicha: obj.codigoFicha
        },
        success: function (data, textStatus, jqXHR) {
          resolve(data);
        }, error: function (jqXHR, textStatus, errorThrown) {
          reject('Error al obtener detalle');
        }
      });
    });
  },
  obtenerDetallePendiente(obj) {
    return new Promise((resolve, reject) => {
      $.ajax({
        url: '../DetalleLoteFichaDocenteServlet',
        dataType: 'json',
        type: 'POST',
        data: {
          accion: 'obtenerDetalleFicha',
          json: JSON.stringify(obj)
        }, beforeSend: function (xhr) {
          load("Obteniendo detalle de la ficha")
        }, success: function (data, textStatus, jqXHR) {
          unload()
          resolve(data)
        }, error: function (jqXHR, textStatus, errorThrown) {
          reject({
            req: obj,
            error: errorThrown
          })
        }
      })
    })
  },
}

let lote;
if (localStorage.getItem('loteGeneral')) {
  lote = getLocal('loteGeneral')
} else {
  window.location = 'consultaLotesGeneral.jsp';
}


printElements.pintarLote();
printElements.cabezeraTabla().then(() => {
  printElements.cuerpoTabla(lote.tipoLote)
  DOMEvents.accionesTabla();
});
