<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@include file="templates/validar.jsp"%>
<!DOCTYPE html>
<html>
  <head>
    <!--Estilos plantilla-->
    <%@include file="templates/header.jsp" %>
    <!--Estilos plantilla-->

    <!--estilos propios-->
    <!--jquery confirm-->
    <!--<link href="../js/lib/jquery-confirm-master/jquery-confirm.min.css" rel="stylesheet" type="text/css"/>-->
    <link href="../css/pages/colors.css" rel="stylesheet" type="text/css"/>
    <link href="../css/pages/general.css" rel="stylesheet" type="text/css"/>
  </head>
  <body onload="cargar();">

    <input id="codTitulo" name="codTitulo" type="hidden" value="<%= menu != null ? menu.getCodigoTitulo() : 0%>">
    <input id="codModulo" type="hidden" value="<%= menu != null ? menu.getCodigoModulo() : 0%>">
    <input id="codCategoria" type="hidden" value="<%= menu != null ? menu.getCodigoCategoria() : 0%>">
    <input id="codSubCategoria" type="hidden" value="<%= menu != null ? menu.getCodigoSubcategoria() : 0%>">


    <!--navbar - sidebar-->
    <%@include file="templates/header-body.jsp" %>
    <!--navbar - sidebar-->

    <!--header-->
    <%@include file="templates/page-header.jsp" %>
    <!--header-->

    <!-- ------------------------------------------------------------------------------------------------------ -->
    <!-- -------------------------------- Panel de criterio de búsqueda --------------------------------------- -->
    <!-- ------------------------------------------------------------------------------------------------------ -->

    <div class="row">
      <div class="col-xs-12 col-md-12 col-lg-12">
        <div class="panel panel-bordered">
          <div class="panel-heading bg-primary">
            <h6 class="panel-title"><i class="fa fa-search fa-lg"></i> Criterio de búsqueda</h6>
          </div>
          <div class="panel-body">
            <div class="row">
              <div class="col-md-3">
                <div class="form-group">
                  <label for="cboCriterio" class="text-semibold">Añadir filtro <span class="text-danger">(*)</span></label>
                  <select class="select" id="cboCriterio">
                    <option value="0">[SELECCIONE UN CRITERIO]</option>
                    <optgroup label="Personal">
                      <option value="1">TIPO DE DOCUMENTO</option>
                      <option value="4">NACIONALIDAD</option>
                      <option value="5">PARENTESCO</option>
                    </optgroup>
                    <optgroup label="Fecha">
                      <option value="6">FECHA DE NACIMIENTO</option>
                      <option value="7">FECHA DE INGRESO</option>
                      <option value="8">FECHA DE TÉRMINO</option>                        
                    </optgroup>
                    <optgroup label="Laboral">
                      <option value="9">SEDE</option>
                      <option value="10">ESTADO</option>
                    </optgroup>
                  </select>
                </div>
              </div>
              <div id="firstDiv"></div>
              <div id="secondDiv"></div>
              <div id="thirdDiv"></div>
            </div>
            <div class="row">
              <div class="col-md-offset-4 col-md-4 text-center" id="actionFilter"></div>    
            </div>
            <div class="row">
              <div class="col-md-12">
                <fieldset>
                  <legend class="text-semibold"><i class="icon-stack-text"></i> Detalle de filtro</legend>
                  <div class="table-responsive">
                    <table class="table table-xxs table-bordered table-hover">
                      <thead>
                        <tr class="bg-slate">
                          <th class="text-center text-bold">#</th>
                          <th>DETALLE FILTRO</th>
                          <th class="text-center">ACCIÓN</th>
                        </tr>
                      </thead>
                      <tbody id="tblBodyDetalleFiltro"></tbody>
                    </table>
                  </div>
                </fieldset>
              </div>
            </div>
          </div>
          <div class="panel-footer">
            <div class="heading-elements">
              <div class="row">
                <div class="col-md-offset-5 col-md-2">
                  <button type="button" class="btn bg-primary heading-btn pull-right btn-block" id="btnConsultarPersonal"><i class="fa fa-search"></i>  Consultar personal</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>


    <!-- ------------------------------------------------------------------------------------------------------ -->
    <!-- ----------------------------------- Panel de resultado ----------------------------------------------- -->
    <!-- ------------------------------------------------------------------------------------------------------ -->

    <div class="row">
      <div class="col-xs-12 col-md-12 col-lg-12">
        <div class="panel panel-bordered">
          <div class="panel-heading bg-primary">
            <h6 class="panel-title"><i class="fa fa-file fa-lg"></i> Resultado de búsqueda</h6>
          </div>
          <div class="table-responsive">
            <table class="table table-xxs table-bordered table-hover">
              <thead>
                <tr>
                  <th class="text-center text-bold">#</th>
                  <th>PERSONAL</th>
                  <th>T DOC.</th>
                  <th>N° DOC.</th>
                  <th>NAC.</th>
                  <th>UBIG. NAC.</th>
                  <th>DIR. DOC.</th>
                  <th>SEXO</th>
                  <th>EST. CIV.</th>
                  <th>F. NAC.</th>
                  <th>TELEF</th>
                  <th>UBIG. RESID.</th>
                  <th>FOND. PEN.</th>
                  <th>SEDE</th>
                  <th>ÁREA</th>
                  <th>CARGO</th>
                  <th>F. ING.</th>
                  <th>F. TER.</th>
                  <th>PARENTESCO</th>
                </tr>
              </thead>
              <tbody id="tblBodyResultadoBusqueda"></tbody>
            </table>
          </div>
          <div class="panel-footer">
            <div class="heading-elements">
              <div class="row">
                <div class="col-md-offset-5 col-md-2">
                  <span class="text-bold text-uppercase" id="totalFilas">Total de resultados filtrados: 0</span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>


    <!--javascript plantilla-->
    <%@include file="templates/footer-body.jsp" %>
    <!--select2-->
    <script type="text/javascript" src="../plantilla/assets/js/core/libraries/jquery_ui/interactions.min.js"></script>
    <script type="text/javascript" src="../plantilla/assets/js/plugins/forms/selects/select2.min.js"></script>

    <!--jquery confirm-->
    <script src="../js/lib/jquery-confirm-master/jquery-confirm.min.js" type="text/javascript"></script>
    <!--datepicker-->
    <script type="text/javascript" src="../plantilla/assets/js/core/libraries/jquery_ui/widgets.min.js"></script>

    <!--javascript general-->
    <script src="../js/pages/general.js" type="text/javascript"></script>
    <script src="../js/pages/menu.js" type="text/javascript"></script>

    <!--javascript propios-->
    <script src="../js/pages/reportePersonal.js" type="text/javascript"></script>

  </body>
</html>
<%}%>